import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import java.sql.*;
import com.ibm.as400.access.*;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.InputStreamReader;
import java.lang.reflect.InvocationTargetException;
import java.util.ResourceBundle;

public class GetItems extends HttpServlet {

	private File file = null;
	private String as400 = null;
	private String userid = null;
	private String password = null;
	private String HOST_NAME = "WDT_HOSTNAME";
	private String USER_ID = "WDT_USERID";
	private String PASSWORD = "WDT_PASSWORD";
	private Connection as400conn = null;
	private DatabaseMetaData dmd = null;
	private int expirationInterval = 60;
	private static String[] hostInfo = null;
	private static String retailLibrary = "retailstor";
	private static String inventoryFile = "inventory";

	public static String[] getHostInfo() {
		return hostInfo;
	}

	public static String getRetailLibrary() {
		return retailLibrary;
	}

	public static String getInventoryFile() {
		return inventoryFile;
	}

	private void setParameterValue(File f) {
		int i;
		StringBuffer buffer = new StringBuffer();
		try {

			FileInputStream fis = new FileInputStream(f);

			BufferedReader br =
				new BufferedReader(new InputStreamReader(fis, "UTF8"));

			// Read file
			String line = br.readLine();
			int index;
			while (line != null) {
				
				index = line.indexOf(HOST_NAME);
				if (index > -1) {
					line = br.readLine();
					i = line.indexOf("<");
					as400 = line.substring(i+13, line.length() - 14);
					line = line.substring(0, index);
				} else {
					index = line.indexOf(USER_ID);
					if (index > -1) {
						line = br.readLine();
						i = line.indexOf("<");
						userid = line.substring(i+13, line.length() - 14);
						line = line.substring(0, index);
					} else {
						index = line.indexOf(PASSWORD);
						if (index > -1) {
							line = br.readLine();
							i = line.indexOf("<");
							password = line.substring(i+13, line.length() - 14);
							line = line.substring(0, index);
							break;
						}

					}
				}

				line = br.readLine();
			}
			br.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public void init() {

		file = new File(getServletContext().getRealPath("/WEB-INF/web.xml"));
		hostInfo = new String[3];

		setParameterValue(file);

		hostInfo[0] = as400;
		hostInfo[1] = userid;
		hostInfo[2] = password;

		try {

			// Load the IBM Toolbox for Java JDBC driver.
			DriverManager.registerDriver(
				new com.ibm.as400.access.AS400JDBCDriver());

			as400conn =
				DriverManager.getConnection(
					"jdbc:as400://" + as400 + ";naming=sql;errors=full",
					userid,
					password);

			dmd = as400conn.getMetaData();
		} catch (Exception exc) {
			exc.printStackTrace();
		}

	}
	public void service(
		HttpServletRequest request,
		HttpServletResponse response)
		throws ServletException, java.io.IOException {
		try {

			if (as400conn.isClosed()) {
				as400conn =
					DriverManager.getConnection(
						"jdbc:as400://" + as400 + ";naming=sql;errors=full",
						userid,
						password);

				dmd = as400conn.getMetaData();
			}
			Statement select =
				as400conn.createStatement(
					ResultSet.TYPE_SCROLL_INSENSITIVE,
					ResultSet.CONCUR_READ_ONLY);
			ResultSet rs =
				select.executeQuery(
					"SELECT PRODNO, PRODNAME, RPRICE, IMAGE FROM "
						+ retailLibrary
						+ dmd.getCatalogSeparator()
						+ inventoryFile);

			HttpSession session = request.getSession(true);
			session.setAttribute("resultset", rs);

			response.sendRedirect("ViewItems.jsp");

		} catch (SQLException sqle) {
			System.out.println(sqle.getMessage());
			sqle.printStackTrace();
		}

	}

}